import java.util.*;
import java.io.IOException;

public class Main{
  static class Board{
    public int n;
    public int m;
    public ArrayList<Thief> thiefs;
    public ArrayList<Police> polices;

    public Board(int n, int m){
      this.n = n;
      this.m = m;
      this.thiefs   = new ArrayList<Thief>();
      this.polices  = new ArrayList<Police>();
    }

    public Boolean isTakenByThief(int x, int y){
      for(Thief t : this.thiefs){
        if( t.x == x && t.y == y ){

          return true;
        }
      }
      return false;
    }

    public Boolean isTakenByPolice(int x, int y){
      for(Police t : this.polices){
        if( t.x == x && t.y == y ){

          return true;
        }
      }
      return false;
    }

    public Boolean isFree(int x, int y){
      if( !isTakenByThief(x, y) && !isTakenByPolice(x, y) ){

        return true;
      }else{
        return false;
      }
    }

    public void print(){
      for(int i = 0; i < n; i++){// Check Bounds
        for(int j = 0; j < m; j++){
          if( isTakenByThief(i, j) ){

            System.out.print("T  ");
          }else if( isTakenByPolice(i, j) ){
            System.out.print("P  ");
          }else{
            System.out.print("-  ");
          }
        }
        System.out.println("");
      }
    }
  }
  static class Thief{
    public int x;
    public int y;

    public Thief(int x, int y){
      this.x = x;
      this.y = y;
    }
  }
  static class Police{
    public int x;
    public int y;

    public Police(int x, int y){
      this.x = x;
      this.y = y;
    }
  }
  public static void main(String[] args) throws IOException, InterruptedException{
    Scanner sc = new Scanner(System.in);
    // Get Data
    System.out.println("Enter N: ");
    int n = Integer.parseInt(sc.next());
    System.out.println("Enter M: ");
    int m = Integer.parseInt(sc.next());
    System.out.println("Enter number of polices: ");
    int p = Integer.parseInt(sc.next());
    System.out.println("Enter number of thiefs: ");
    int t = Integer.parseInt(sc.next());
    // Initialize Board
    Board mainBoard = new Board(n, m);
    Random rand = new Random();
    // Create Polices
    for(int i = 0; i < p; i++){
      boolean flag = true;
      int x = 0, y = 0;
      while(flag){
        x = rand.nextInt(n);
        y = rand.nextInt(m);
        flag = !mainBoard.isFree(x, y);
      }
      Police newPolice = new Police(x, y);
      mainBoard.polices.add(newPolice);
    }
    // Create Thiefs
    for(int i = 0; i < p; i++){
      boolean flag = true;
      int x = 0, y = 0;
      while(flag){
        x = rand.nextInt(n);
        y = rand.nextInt(m);
        flag = !mainBoard.isFree(x, y);
      }
      Thief newThief = new Thief(x, y);
      mainBoard.thiefs.add(newThief);
    }
    // Print fucking board
    new ProcessBuilder("cmd", "/c", "cls").inheritIO().start().waitFor();
    mainBoard.print();
    sc.close();
  }
}
